-- Phrase variables
BINDING_HEADER_BANKGUI = "BankGUI";
BINDING_NAME_BANKGUITOGGLE = "Show or hide the BankGUI Tab.";

BANKGUIS_TO_DISPLAY = 18;
FRIENDS_FRAME_BANKGUI_HEIGHT = 16;

BANKGUI_TABNAME			= "Bank";
BANKGUI_TITLE			= "BankGUI 1.6";
BANKGUI_GUILD			= "Guild";
BANKGUI_DELETE			= "Delete items";

BANKGUI_DETAILS_OF		= "Owner: |cffffffff%s|r";
BANKGUI_AMOUNT			= "Amount:";
BANKGUI_TYPE			= "Item Type:";
BANKGUI_LEVEL			= "Item Level:";
BANKGUI_INVENT			= "Inventory: |cffffffff%s|r";
BANKGUI_EQUIP			= "Equipslot: |cffffffff%s|r";
BANKGUI_VENDOR			= "Vendor value:";


bank_chat = ChatFrame1;
bank_playername = nil;
bank_guildname = nil;

GOLD_BANK = "Total Gold: |cffffffff%.2f|r";
GOLD_GUILD = "Gold: |cffffffff%.2f|r";

BankGUI = {};

BankList = {};
BankFilter = {};

BankListPlayers = {};
BankListItems = {};

BankListGuildItems = {};
BankListGuildInfo = {};

BankListOptions = {};

Wisp_Data = {};



-- Function to handle onload event
function BankGUI:OnLoad()

	-- constructions
	self:InsertUI();
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_LOGIN");
	this:RegisterEvent("PLAYER_MONEY");
	this:RegisterEvent("PLAYER_GUILD_UPDATE");
	this:RegisterEvent("CHAT_MSG_WHISPER");
	this:RegisterEvent("CHAT_MSG_PARTY");
	this:RegisterEvent("CHAT_MSG_RAID");
	this:RegisterEvent("CHAT_MSG_GUILD");
	this:RegisterEvent("CHAT_MSG_CHANNEL");
	this:RegisterEvent("BANKFRAME_OPENED");
	this:RegisterEvent("CRAFT_SHOW");
	this:RegisterEvent("TRADE_SKILL_SHOW");
	this:RegisterEvent("GUILDBANKFRAME_OPENED");

	bank_chat:AddMessage("BankGUI 1.6 loaded. Go to |cffffff80Social (O)|r and select the |cffffff80Bank|r tab on the bottom right.", 0.5,1,1);
	SLASH_BANK1 = "/bank";
	SlashCmdList["BANK"] = function(msg)
		Bank_SlashCommandHandler(msg);
	end

end


-- Function to handle events
function BankGUI:HandleEvent(event)

	if (event == "VARIABLES_LOADED") then
		local playerinfo = {["name"] = "", ["money"] = 0 };
		local optionsinfo = {["guild_checked"] = false, ["guild_name"] = nil, ["player_name"] = nil, ["player_type"] = 1};
		local i, element_exists = 0, false;
		if not BankListOptions then BankListOptions = {} end
		if not BankListOptions[GetRealmName()] then BankListOptions[GetRealmName()] = {} end
		if not BankListOptions[GetRealmName()][1] then
			BankGUIDeleteButton:Disable();
			table.insert( BankListOptions[GetRealmName()], optionsinfo );
		end

		if not BankListGuildInfo then BankListGuildInfo = {} end
		if not BankListGuildInfo[GetRealmName()] then BankListGuildInfo[GetRealmName()] = {} end

		if not BankListGuildItems then BankListGuildItems = {} end
		if not BankListGuildItems[GetRealmName()] then BankListGuildItems[GetRealmName()] = {} end

		bank_playername = UnitName("player");
		bank_guildname = GetGuildInfo("player");

		playerinfo["name"] = bank_playername;
		playerinfo["money"] = GetMoney();
		if not BankFilter then BankFilter = {} end
		if not BankFilter[GetRealmName()] then BankFilter[GetRealmName()] = {} end
		if not BankListItems then BankListItems = {} end
		if not BankListItems[GetRealmName()] then BankListItems[GetRealmName()] = {} end
		if not BankListPlayers then BankListPlayers = {} end
		if not BankListPlayers[GetRealmName()] then BankListPlayers[GetRealmName()] = {} end
		if bank_playername then
			element_exists = false;
			for i = 1,table.getn(BankListPlayers[GetRealmName()]) do
				if BankListPlayers[GetRealmName()][i]["name"]==bank_playername then
					BankListPlayers[GetRealmName()][i]["money"] = GetMoney();
					element_exists = true;
				end
			end
			if not element_exists then
				table.insert( BankListPlayers[GetRealmName()], playerinfo );
				table.sort(BankListPlayers[GetRealmName()], function(a,b) return a["name"]<b["name"] end);
			end
		end
	end

	if (event == "PLAYER_LOGIN") then
		local playerinfo = {["name"] = "", ["money"] = 0, };
		local i, element_exists = 0, false;
		bank_playername = UnitName("player");
		if bank_playername then
			playerinfo["money"] = GetMoney();
			element_exists = false;
			for i = 1,table.getn(BankListPlayers[GetRealmName()]) do
				if BankListPlayers[GetRealmName()][i]["name"]==bank_playername then
					BankListPlayers[GetRealmName()][i]["money"] = GetMoney();
					element_exists = true;
				end
			end
			if not element_exists then
				table.insert( BankListPlayers[GetRealmName()], playerinfo );
				BankListPlayers[GetRealmName()][table.getn(BankListPlayers[GetRealmName()])]["money"] = GetMoney();
				table.sort(BankListPlayers[GetRealmName()], function(a,b) return a["name"]<b["name"] end);
			end
		end
		BankGUICheckButton:SetChecked(BankListOptions[GetRealmName()][1]["guild_checked"]);
		BankGUICheckButton_OnClick(BankGUICheckButton);
		BankGUI:UpdateFilter(nil);
	end

	if (event == "PLAYER_GUILD_UPDATE" and not bank_guildname) then
		local guildinfo = {["name"] = "", ["money"] = 0, };
		local i, element_exists = 0, false;
		bank_guildname = GetGuildInfo("player");
		if bank_guildname then
			if not BankListGuildItems[GetRealmName()][bank_guildname] then BankListGuildItems[GetRealmName()][bank_guildname] = {} end
			guildinfo["name"] = bank_guildname;
			guildinfo["money"] = GetGuildBankMoney();
			for i = 1,table.getn(BankListGuildInfo[GetRealmName()]) do
				if BankListGuildInfo[GetRealmName()][i]["name"] == bank_guildname then element_exists = true end
			end
			if not element_exists then table.insert(BankListGuildInfo[GetRealmName()], guildinfo) end
			BankGUICheckButton:SetChecked(BankListOptions[GetRealmName()][1]["guild_checked"]);
			BankGUICheckButton_OnClick(BankGUICheckButton);
			BankGUI:UpdateFilter(nil);
		end
	end

	if (event == "PLAYER_MONEY") then
		local bank_gold_tot = 0.0;
		bank_playername = UnitName("player");
		bank_guildname = GetGuildInfo("player");
		for i = 1,table.getn(BankListPlayers[GetRealmName()]) do
			if BankListPlayers[GetRealmName()][i]["name"]==bank_playername then
				BankListPlayers[GetRealmName()][i]["money"] = GetMoney();
			end
			bank_gold_tot = bank_gold_tot + (BankListPlayers[GetRealmName()][i]["money"]/10000);
		end
		if not BankListOptions[GetRealmName()][1]["guild_checked"] then BankGUITotalGold:SetText( format(GOLD_BANK,bank_gold_tot) ) end
	end

	if ( event == "CHAT_MSG_WHISPER" ) then
		local wispinfo = { ["name"] = arg2 };
		local i, element_exists = 1, false;
		for i = 1, table.getn(Wisp_Data) do
			if Wisp_Data[i]["name"] == arg2 then element_exists = true end
		end
		if not element_exists then table.insert(Wisp_Data, wispinfo) end
		if ( string.sub(arg1,1,1)=="!" and string.len(arg1)>1 ) then
			local craftable=string.lower( string.sub(arg1,2) );
			local j = 0;
			for i = 1, table.getn(BankListItems[GetRealmName()]) do 
				if ( string.find(string.lower(BankListItems[GetRealmName()][i]["item"]),craftable)~=nil ) then
					if j < 10 then SendChatMessage(BankListItems[GetRealmName()][i]["item"], "WHISPER", nil, arg2)
					else
						SendChatMessage("--- Too many items found. Listing is stopped. ---", "WHISPER", nil, arg2);
						break;
					end
					j = j + 1;
				end
			end
		end
	end

	if ( event == "BANKFRAME_OPENED" ) then
		local i,j,k,itemlink,texture,itemCount;
		while BankGUI:GetBankItemIndexByName(bank_playername)~=0 do
			table.remove( BankListItems[GetRealmName()], BankGUI:GetBankItemIndexByName(bank_playername) );
		end
		k = 1;
		for j=-2,11 do
		for i = 1, GetContainerNumSlots(j) do
			itemlink = GetContainerItemLink(j,i);
			texture, itemCount = GetContainerItemInfo(j,i);
			if texture then BankGUI:AddItem(itemlink, itemCount, true, nil, false, j) end
		end
		end
		for i = 0, 19 do
			itemlink=GetInventoryItemLink("player", i);
			if itemlink then BankGUI:AddItem(itemlink, 1, true, nil, false, -3) end
		end
		BankGUI:UpdateFilter(nil);
	end

	if ( event == "CRAFT_SHOW" ) then
		local i = 0;
		local sName, sSub, sType, itemlink;
		for i = 1, GetNumCrafts() do
			sName, sSub, sType = GetCraftInfo(i);
			if (sName and sType ~= "header") then
				itemlink = GetCraftRecipeLink(i);
				if not BankGUI:GetSkillItemByName(itemlink, sType) then BankGUI:AddItem(itemlink, 1, false, sType, false, nil) end
			end
		end
		BankGUI:UpdateFilter(nil);
	end

	if ( event == "TRADE_SKILL_SHOW" ) then
		local i = 0;
		local sName, sType, itemlink;
		for i = 1, GetNumTradeSkills() do
			sName, sType = GetTradeSkillInfo(i);
			if ( sName and sType ~= "header" ) then
				itemlink = GetTradeSkillRecipeLink(i);
				if not BankGUI:GetSkillItemByName(itemlink, sType) then BankGUI:AddItem(itemlink, 1, false, sType, false, nil) end
			end
		end
		BankGUI:UpdateFilter(nil);
	end

	if ( event == "GUILDBANKFRAME_OPENED" ) then
		local i,j,k,itemlink,texture,itemCount;
		local guildinfo = {["name"] = "", ["money"] = 0 };
		local element_exists = false;
		bank_guildname = GetGuildInfo("player");
		if not BankListGuildItems then BankListGuildItems = {} end
		if not BankListGuildItems[GetRealmName()] then BankListGuildItems[GetRealmName()] = {} end
		if bank_guildname then
			guildinfo["name"] = bank_guildname;
			guildinfo["money"] = GetGuildBankMoney();
			if not BankListGuildInfo then BankListGuildInfo = {} end
			if not BankListGuildInfo[GetRealmName()] then BankListGuildInfo[GetRealmName()] = {} end
			for i = 1,table.getn(BankListGuildInfo[GetRealmName()]) do
				if BankListGuildInfo[GetRealmName()][i]["name"] == bank_guildname then element_exists = true end
			end
			if not element_exists then table.insert(BankListGuildInfo[GetRealmName()], guildinfo) end
		end
		BankListGuildItems[GetRealmName()][bank_guildname] = {};
		for j = 1, GetNumGuildBankTabs() do
			QueryGuildBankTab(j);
			for i = 1, 98 do
				itemlink = GetGuildBankItemLink(j,i);
				texture, itemCount = GetGuildBankItemInfo(j,i);
				if texture then BankGUI:AddItem(itemlink, itemCount, true, nil, true, nil) end
			end
		end
		for i = 1, table.getn(BankListGuildInfo[GetRealmName()]) do
			if BankListGuildInfo[GetRealmName()][i]["name"] == bank_guildname then BankListGuildInfo[GetRealmName()][i]["money"] = GetGuildBankMoney() end
		end
		BankGUICheckButton_OnClick(BankGUICheckButton);
		BankGUI:UpdateFilter(nil);
	end
	if ( event == "CHAT_MSG_WHISPER" or event == "CHAT_MSG_PARTY" or event == "CHAT_MSG_RAID" or event == "CHAT_MSG_GUILD" or event == "CHAT_MSG_CHANNEL" ) then
		if string.find(arg1,"BankGUI")~=nil then return end
		local tradeinfo, substr,linkstr, i, j = { }, nil, nil, string.find(arg1,"|Htrade");
		if i~=nil then
			j = string.find(arg1, "|h|r");
			linkstr = string.sub(arg1, (i-10), (j+3));
			i = string.find(arg1, "|h", (i+7));
			substr = string.sub(arg1, (i+3), (j-2));
			if linkstr == nil or substr == nil then return end
			for i = 1, table.getn(BankListItems[GetRealmName()]) do
				if BankListItems[GetRealmName()][i]["type"] == "-4" and BankListItems[GetRealmName()][i]["name"] == arg2 and string.find(BankListItems[GetRealmName()][i]["item"],substr)~=nil then
					BankListItems[GetRealmName()][i]["item"] = linkstr;
					BankListItems[GetRealmName()][i]["amount"] = date("%d/%m/%y %H:%M");
					return;
				end
			end
			if event == "CHAT_MSG_CHANNEL" then return end
			tradeinfo["type"] = "-4";
			tradeinfo["name"] = arg2;
			tradeinfo["amount"] = date("%d/%m/%y %H:%M");
			tradeinfo["item"] = linkstr;
			tradeinfo["bank"] = false;
			table.insert(BankListItems[GetRealmName()], tradeinfo);
		end
	end

end

function Bank_SlashCommandHandler(msg)
	bank_chat:AddMessage("", 0.5,1,1);
	bank_chat:AddMessage("BankGUI help:", 0.5,1,1);
	bank_chat:AddMessage("Go to Social |cffffff80(O)|r and select the Bank tab at the bottomright of the window.", 0.5,1,1);
	bank_chat:AddMessage("There you see a list of items that are in bags/bank/equiped on all your characters.", 0.5,1,1);
	bank_chat:AddMessage("Also, if you open a Tradeskill window, all the items you can make will be added to the list.", 0.5,1,1);
	bank_chat:AddMessage("You can apply filters, like display all items from a specific character, or type text to find specific items.", 0.5,1,1);
	bank_chat:AddMessage("|cffffff80NOTE:|r items only get added/updated to the list when you open your Bank/Tradeskill window.", 0.5,1,1);
end
