function BankGUI:AddItem(item, amount, bank, type, guild, bagid)
	local bankguiinfo;
	-- handle item
	if (item == nil) then return end
	-- handle amount
	if (amount == nil or amount == 0) then amount = 1 end
	-- handle bank/skill item
	if (bank == nil) then bank = true end
	if (type == nil and bagid ~= nil) then type = "" ..bagid end

	if (guild == nil) then guild = false end

	if guild then
		bankguiinfo = {["item"] = item, ["amount"] = amount};
		table.insert(BankListGuildItems[GetRealmName()][bank_guildname], bankguiinfo);
	else
		bankguiinfo = {["name"] = bank_playername, ["item"] = item, ["amount"] = amount, ["bank"] = bank, ["type"] = type};
		table.insert(BankListItems[GetRealmName()], bankguiinfo);
	end
	-- self:UpdateUI();
end


function BankGUI:GetNumGuilds()
	if not BankListGuildInfo then return 0 end
	if not BankListGuildInfo[GetRealmName()] then return 0 end
	return table.getn(BankListGuildInfo[GetRealmName()]);
end


function BankGUI:GetGuild(index)
	if not BankListGuildInfo[GetRealmName()] then return ""
	elseif BankListGuildInfo[GetRealmName()][index] then return BankListGuildInfo[GetRealmName()][index]["name"]
	else return "" end
end


-- Returns the number of players in list
function BankGUI:GetNumCharacters()
	if BankFilter[GetRealmName()] then return table.getn(BankFilter[GetRealmName()]) else return 0 end
end


function BankGUI:GetBankItemIndexByName(name)
	local i;
	for i = 1, table.getn(BankListItems[GetRealmName()]) do
--		if ( BankListItems[GetRealmName()][i]["bank"] == true and BankListItems[GetRealmName()][i]["name"] == name ) then return i end
		if ( BankListItems[GetRealmName()][i]["name"] == name ) then return i end
	end
	return 0
end


function BankGUI:GetSkillItemByName(item, type)
	local i;
	for i = 1, table.getn(BankListItems[GetRealmName()]) do
		if BankListItems[GetRealmName()][i]["bank"] == false and BankListItems[GetRealmName()][i]["item"] == item then
			if type~="header" then BankListItems[GetRealmName()][i]["type"] = type end
			if string.find( BankListItems[GetRealmName()][i]["name"],bank_playername )==nil then
				BankListItems[GetRealmName()][i]["name"] = BankListItems[GetRealmName()][i]["name"] .."," ..bank_playername;
			end
			return true;
		 end
	end
	return false;
end


-- Returns the index of the player given by name
function BankGUI:GetIndexByName(name)
	for i = 1, self:GetNumCharacters() do
		if (self:GetNameByIndex(i) == name) then
			return i
		end
	end
	return 0
end


-- Returns the name of the player given by index
function BankGUI:GetNameByIndex(index)

	if (index < 1 or index > self:GetNumCharacters()) then
		return nil;
	end

	player = BankFilter[GetRealmName()][index];
	return player["name"];

end


-- Returns the player object given by index
function BankGUI:GetItemByIndex(index)

	if (index < 1 or index > self:GetNumCharacters()) then
		return nil
	end

	return BankFilter[GetRealmName()][index];

end
