
local SelectedIndex = 1;
local ClickedIndex = 1;
local SelectedID = nil;
local filterstring = "";
local TypesIndex = 1;
local PlayerIndex = 1;

local tradecolors = {
	["trivial"] = "|cff808080",
	["easy"] = "|cff00ff00",
	["medium"] = "|cffffff00",
	["optimal"] = "|cffff8000",
	["difficult"] = "|cffff0000",
};

local linktochattypes = {
	{"Link to:", nil, true},
	{"RAID", nil, false},
	{"PARTY", nil, false},
	{"GUILD", nil, false},
	{"SAY", nil, false},
	{"FRIEND", 1, false},
	{"WHISPERS", 1, false},
};

local Link_Data = {
	["Link to:"] = {},
	["RAID"] = {},
	["PARTY"] = {},
	["GUILD"] = {},
	["SAY"] = {},
	["FRIEND"] = {},
	["WHISPERS"] = {},
};

local Item_Type = {
	[""] = "",
	["-4"] = "TradeLink",
	["-3"] = "Equiped",
	["-2"] = "Keyring",
	["-1"] = "Bankslot 1/28",
	["0"] = "Backpack",
	["1"] = "Bag 1",
	["2"] = "Bag 2",
	["3"] = "Bag 3",
	["4"] = "Bag 4",
	["5"] = "BankBag 1",
	["6"] = "BankBag 2",
	["7"] = "BankBag 3",
	["8"] = "BankBag 4",
	["9"] = "BankBag 5",
	["10"] = "BankBag 6",
	["11"] = "BankBag 7",
};

local Types_Data = {
	"Everything",
	"Items",
	"Tradeskills",
	"Profession Links",
};


-- Inserts all of the UI elements
function BankGUI:InsertUI()
	-- Add tab button to SocialFrame
	CreateFrame("Button", "FriendsFrameTab6", getglobal("FriendsDropDown"), "FriendsFrameTab6");
	PanelTemplates_SetNumTabs(getglobal("FriendsFrame"), 6);

	-- Add the tab itthis
	table.insert(FRIENDSFRAME_SUBFRAMES, "BankGUIFrame");
	CreateFrame("Frame", "BankGUIFrame", getglobal("FriendsFrame"), "BankGUIFrame");
end

function BankGUI:SetSelectedBankGUI(index)
	SelectedIndex = index;
end

function BankGUI:GetSelectedBankGUI()
	return SelectedIndex;
end

function BankGUI:ShowTab()
	FriendsFrameTopLeft:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-General-TopLeft");
	FriendsFrameTopRight:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-General-TopRight");
	FriendsFrameBottomLeft:SetTexture("Interface\\FriendsFrame\\UI-FriendsFrame-BotLeft");
	FriendsFrameBottomRight:SetTexture("Interface\\FriendsFrame\\UI-FriendsFrame-BotRight");
	FriendsFrameTitleText:SetText(BANKGUI_TITLE);
	FriendsFrame_ShowSubFrame("BankGUIFrame");
	PanelTemplates_SetTab(FriendsFrame, 6);
	BankGUI:UpdateFilter(nil);
end

function BankGUI:ToggleTab()
	ToggleFriendsFrame();
	if (FriendsFrame:IsVisible()) then
		getglobal("FriendsListFrame"):Hide();
		BankGUI:ShowTab();
	else BankGUIFrame:Hide() end
--	if (BankGUIFrame:IsVisible()) then BankGUIFrame:Hide()
--	else BankGUI:ShowTab() end
end

function BankGUI:OnEnter()
	if TypesIndex == 4 and not BankListOptions[GetRealmName()][1]["guild_checked"] then return end
	local bankinfo = BankGUI:GetItemByIndex(this:GetID());
	if not bankinfo then return end
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture;
	local dispstring;
	itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(bankinfo["item"]);
	if itemMinLevel == nil then itemMinLevel = 0 end
	if itemStackCount == nil then itemStackCount = 1 end
	if itemTexture == nil then
		if string.find(bankinfo["item"],"Alchemy:") then itemSubType = "Alchemy"
		elseif string.find(bankinfo["item"],"Blacksmithing:") then itemSubType = "Blacksmithing"
		elseif string.find(bankinfo["item"],"Enchanting:") or string.find(bankinfo["item"],"Enchant ") then itemSubType = "Enchanting"
		elseif string.find(bankinfo["item"],"Engineering:") then itemSubType = "Engineering"
		elseif string.find(bankinfo["item"],"Jewelcrafting:") then itemSubType = "Jewelcrafting"
		elseif string.find(bankinfo["item"],"Leatherworking:") then itemSubType = "Leatherworking"
		elseif string.find(bankinfo["item"],"Tailoring:") then itemSubType = "Tailoring"
		elseif string.find(bankinfo["item"],"Mining:") then itemSubType = "Mining"
		elseif string.find(bankinfo["item"],"Cooking:") then itemSubType = "Cooking"
		elseif string.find(bankinfo["item"],"First Aid:") then itemSubType="First Aid"
		end
	end
	if itemSubType == nil then itemSubType = "" end
	if itemType == nil then
		itemType = itemSubType;
		itemSubType = "";
	end
	GameTooltip:SetOwner(this,"ANCHOR_BOTTOMRIGHT");
	GameTooltip:ClearLines();
	if IsShiftKeyDown() then GameTooltip:SetHyperlink(bankinfo["item"])
	else
		if BankListOptions[GetRealmName()][1]["guild_checked"] then
			dispstring = bankinfo["item"];
		else
			dispstring = format("%s\nOwner: |cffffffff%s|r", bankinfo["item"], bankinfo["name"]);
		end
		if itemStackCount ~= 1 then dispstring = dispstring ..format("\n%s |cffffffff%i|r", BANKGUI_AMOUNT, bankinfo["amount"]) end
		if bankinfo["bank"] == true and TypesIndex ~= 4 then
			if itemStackCount ~= 1 then dispstring = dispstring ..format(" / |cffffffff%i|r", itemStackCount) end
			dispstring=dispstring ..format("\n%s |cffffffff%s,%s|r\n%s |cffffffff%i|r\n", BANKGUI_TYPE, itemType, itemSubType, BANKGUI_LEVEL, itemMinLevel);
			if bankinfo["type"] ~= nil then dispstring=dispstring ..format(BANKGUI_INVENT, Item_Type[bankinfo["type"]]) end
		else
			dispstring=dispstring ..format("\n%s |cffffffff%s,%s|r\n", BANKGUI_TYPE, itemType, itemSubType);
			if bankinfo["type"] ~= nil then
				dispstring=dispstring ..BANKGUI_LEVEL;
				if tradecolors[bankinfo["type"]] then dispstring=dispstring ..format(" %s%s|r\n", tradecolors[bankinfo["type"]], bankinfo["type"])
				else dispstring=dispstring .." |cffffffff" ..bankinfo["type"] .."|r\n";
				end
				dispstring=dispstring ..format(BANKGUI_INVENT, "Tradeskill");
			end
		end
		if (itemEquipLoc and _G[itemEquipLoc]) then
			dispstring=dispstring .."\n" ..format(BANKGUI_EQUIP, _G[itemEquipLoc]);
		end
		GameTooltip:SetText(dispstring);
	end
end

function BankGUI:ClickBankGUI(button)
	local index = this:GetID();
	if (IsControlKeyDown() and TypesIndex ~= 4) then
		local bankinfo = BankGUI:GetItemByIndex(index);
		DressUpItemLink(bankinfo["item"]);
	else
		if (button == "LeftButton") then
			BankGUI:SetSelectedBankGUI(index);
			BankGUI:UpdateUI();
			if TypesIndex == 4 and not BankListOptions[GetRealmName()][1]["guild_checked"] then
				if IsControlKeyDown() then
					local bankinfo = BankGUI:GetItemByIndex(index);
					bank_chat:AddMessage( format("BankGUI: |cffffff80%s|r %s |cffffff80(%s)|r", bankinfo["name"], bankinfo["item"], bankinfo["amount"]), 0.5,1,1 );
				end
			else
				BankGUI:ShowDetails();
			end
		else
			ClickedIndex = index;
			HideDropDownMenu(1);
			BankGUILinkDropDown.initialize = BankGUILinkDropDown_Initialize;
			BankGUILinkDropDown.displayMode = "MENU";
			BankGUILinkDropDown.name = "Link in:";
			BankGUILinkDropDown.lineID = 0;
			ToggleDropDownMenu(1, nil, BankGUILinkDropDown, "cursor");
		end
	end
end

function BankGUI:ShowDetails()
	-- get info
	local bankinfo = BankGUI:GetItemByIndex(BankGUI:GetSelectedBankGUI());
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(bankinfo["item"]);
	local textur = getglobal("BankGUIDetailsFactionInsignia");
	local amount = getglobal("BankGUIDetailsAmountText");
	local level  = getglobal("BankGUIDetailsLevelText");
	local itemt  = getglobal("BankGUIDetailsItemText");
	local prefix = "Interface\\Icons\\";

	-- update details
	if itemName then itemt:SetText( itemName )
	else itemt:SetText( bankinfo["item"] ) end
	if itemMinLevel == nil then itemMinLevel = 0 end
	if itemStackCount == nil then itemStackCount = 1 end
	if itemTexture == nil then
		if string.find(bankinfo["item"],"Alchemy:") then itemTexture=prefix.."Trade_Alchemy";itemSubType="Alchemy";
		elseif string.find(bankinfo["item"],"Blacksmithing:") then itemTexture=prefix.."Trade_Blacksmithing";itemSubType="Blacksmithing";
		elseif string.find(bankinfo["item"],"Enchanting:") or string.find(bankinfo["item"],"Enchant ") then itemTexture=prefix.."Trade_Engraving";itemSubType="Enchanting";
		elseif string.find(bankinfo["item"],"Engineering:") then itemTexture=prefix.."Trade_Engineering";itemSubType="Engineering";
		elseif string.find(bankinfo["item"],"Inscription:") then itemTexture=prefix.."INV_Inscription_Tradeskill01";itemSubType="Inscription";
		elseif string.find(bankinfo["item"],"Jewelcrafting:") then itemTexture=prefix.."INV_Misc_Gem_02";itemSubType="Jewelcrafting";
		elseif string.find(bankinfo["item"],"Leatherworking:") then itemTexture=prefix.."Trade_Leatherworking";itemSubType="Leatherworking";
		elseif string.find(bankinfo["item"],"Tailoring:") then itemTexture=prefix.."Trade_Tailoring";itemSubType="Tailoring";
		elseif string.find(bankinfo["item"],"Mining:") then itemTexture=prefix.."Trade_Mining";itemSubType="Mining";
		elseif string.find(bankinfo["item"],"Cooking:") then itemTexture=prefix.."INV_Misc_Food_15";itemSubType="Cooking";
		elseif string.find(bankinfo["item"],"First Aid:") then itemTexture=prefix.."Spell_Holy_SealOfSacrifice";itemSubType="First Aid";
		end
	end
	textur:SetTexture(itemTexture);
	if itemSubType == nil then itemSubType = "" end
	if itemType == nil then
		itemType = itemSubType;
		itemSubType = "";
	end
	textur:SetTexCoord(0, 1, 0, 1);
	if bankinfo["bank"] == true then
		if itemStackCount ~= 1 then amount:SetText( format("%i / %i", bankinfo["amount"], itemStackCount) )
		else amount:SetText( format("%i", bankinfo["amount"]) )
		end
		level:SetText( "" .. itemMinLevel );
	else
		amount:SetText( "" );
		if bankinfo["type"]~=nil then
			if tradecolors[bankinfo["type"]] then level:SetText( format("%s%s|r",tradecolors[bankinfo["type"]],bankinfo["type"]) )
			else level:SetText( bankinfo["type"] )
			end
		else level:SetText( "" )
		end
	end
	getglobal("BankGUIDetailsTypeText"):SetText( itemType ..", " ..itemSubType );
	if not BankListOptions[GetRealmName()][1]["guild_checked"] then
		getglobal("BankGUIDetailsName"):SetText( format(BANKGUI_DETAILS_OF,bankinfo["name"]) );
		if bankinfo["bank"] == true then getglobal("BankGUIDetailsLoca"):SetText( format(BANKGUI_INVENT,Item_Type[bankinfo["type"]]) )
		else getglobal("BankGUIDetailsLoca"):SetText( format(BANKGUI_INVENT,"Tradeskill") )
		end
	end
	getglobal("BankGUIDetailsFrame"):Show();
end

function BankGUICheckButton_OnClick(this)
	local i;
	CloseDropDownMenus();
	BankListOptions[GetRealmName()][1]["guild_checked"] = this:GetChecked();
	PlayerIndex = 1;
	if BankListOptions[GetRealmName()][1]["guild_checked"] then
		TypesIndex = 1;
		SelectedID = BankListOptions[GetRealmName()][1]["guild_name"];
		BankGUIPlayerTitle:SetText("Guild:");
		UIDropDownMenu_DisableDropDown(BankGUITypeDropDown);
		for i = 1, BankGUI:GetNumGuilds() do
			if BankListOptions[GetRealmName()][1]["guild_name"] and BankGUI:GetGuild(i) == BankListOptions[GetRealmName()][1]["guild_name"] then PlayerIndex = i end
		end
	else
		if BankListOptions[GetRealmName()][1]["player_name"] then SelectedID = BankListOptions[GetRealmName()][1]["player_name"]
		else SelectedID = nil end
		if BankListOptions[GetRealmName()][1]["player_type"] then TypesIndex = BankListOptions[GetRealmName()][1]["player_type"] end
		BankGUIPlayerTitle:SetText("Char:");
		UIDropDownMenu_EnableDropDown(BankGUITypeDropDown);
		for i = 1, table.getn(BankListPlayers[GetRealmName()]) do
			if SelectedID and BankListPlayers[GetRealmName()][i]["name"] == SelectedID then PlayerIndex = (i+1) end
		end
	end
--	BankGUIPlayerDropDown_Initialize();
	UIDropDownMenu_SetSelectedID(BankGUITypeDropDown, TypesIndex);
	UIDropDownMenu_Initialize(BankGUIPlayerDropDown, BankGUIPlayerDropDown_Initialize);
	UIDropDownMenu_SetSelectedID(BankGUIPlayerDropDown, PlayerIndex);
	if BankListOptions[GetRealmName()][1]["guild_checked"] then
		SelectedID = BankGUI:GetGuild(PlayerIndex);
		UIDropDownMenu_SetText(BankGUITypeDropDown, Types_Data[1]);
		UIDropDownMenu_SetText(BankGUIPlayerDropDown, SelectedID);
		if SelectedID == "" then BankGUIDeleteButton:Disable()
		else BankGUIDeleteButton:Enable() end
	else
		UIDropDownMenu_SetText(BankGUITypeDropDown, Types_Data[TypesIndex]);
		if PlayerIndex == 1 then
			UIDropDownMenu_SetText(BankGUIPlayerDropDown, "All Characters");
			SelectedID = nil;
			BankListOptions[GetRealmName()][1]["player_name"] = nil;
			BankGUIDeleteButton:Disable();
		else
			SelectedID = BankListPlayers[GetRealmName()][PlayerIndex-1]["name"];
			UIDropDownMenu_SetText(BankGUIPlayerDropDown, SelectedID);
			BankGUIDeleteButton:Enable();
		end
	end
	BankGUI:UpdateFilter(nil);
end

function BankGUIDeleteButton_OnClick()
	CloseDropDownMenus();
	StaticPopupDialogs["DELETE_CHARACTER"] = {
		text = "Are you sure you want to delete all items of |cffffff00%s|r from the list?\n\n( NOTE: |cffffff00%s|r will also be removed from the dropdown menu's )",
		button1 = "Yes",
		button2 = "No",
		OnAccept = function()
			BankGUIDeleteButton_OnYes();
		end,
		timeout = 0,
		whileDead = 1,
		showAlert = 1,
		hideOnEscape = 1
	};
	StaticPopup_Show("DELETE_CHARACTER", SelectedID, SelectedID);
end

function BankGUIDeleteButton_OnYes()
  local i;
  CloseDropDownMenus();
  getglobal("BankGUIDetailsFrame"):Hide();
  if BankListOptions[GetRealmName()][1]["guild_checked"] then
	for i = 1, BankGUI:GetNumGuilds() do
		if BankListGuildInfo[GetRealmName()][i] and BankListGuildInfo[GetRealmName()][i]["name"] == SelectedID then table.remove(BankListGuildInfo[GetRealmName()],i) end
	end
	if not BankListGuildItems[GetRealmName()] then return end
	if not BankListGuildItems[GetRealmName()][SelectedID] then return end
	while BankListGuildItems[GetRealmName()][SelectedID][1] do
		table.remove( BankListGuildItems[GetRealmName()][SelectedID] );
	end
	if BankListOptions[GetRealmName()][1]["guild_name"] and BankListOptions[GetRealmName()][1]["guild_name"] == SelectedID then
		BankListOptions[GetRealmName()][1]["guild_name"] = BankGUI:GetGuild(1);
		SelectedID = BankListOptions[GetRealmName()][1]["guild_name"];
	end
  else
	while BankGUI:GetBankItemIndexByName(SelectedID)~=0 do
		table.remove( BankListItems[GetRealmName()], BankGUI:GetBankItemIndexByName(SelectedID) );
	end
	for i = 1, table.getn(BankListPlayers[GetRealmName()]) do
		if BankListPlayers[GetRealmName()][i] and BankListPlayers[GetRealmName()][i]["name"] == SelectedID then table.remove(BankListPlayers[GetRealmName()],i) end
	end
  end
  BankGUICheckButton_OnClick(BankGUICheckButton);
  BankGUI:UpdateFilter(nil);
end

function BankGUITypeDropDown_Initialize()
	local i;
	local typeinfo = UIDropDownMenu_CreateInfo();
	for i = 1, table.getn(Types_Data) do
		typeinfo.text = Types_Data[i];
		typeinfo.value = Types_Data[i];
		typeinfo.func = BankGUITypeDropDown_OnClick;
		typeinfo.owner = this:GetParent();
		typeinfo.checked = nil;
		typeinfo.hasArrow = false;
		typeinfo.notCheckable = false;
		UIDropDownMenu_AddButton(typeinfo);
 	end
end

function BankGUITypeDropDown_OnClick()
	UIDropDownMenu_SetSelectedID(this.owner, this:GetID());
	TypesIndex = this:GetID();
	if not BankListOptions[GetRealmName()][1]["guild_checked"] then BankListOptions[GetRealmName()][1]["player_type"] = this:GetID() end
	BankGUI:UpdateFilter(nil);
end

function BankGUIPlayerDropDown_Initialize()
  local i,bank_gold,bank_gold_tot = 0, 0.0, 0.0;
  local playerinfo = UIDropDownMenu_CreateInfo();
  if not BankListOptions then return end
  if not BankListOptions[GetRealmName()] then return end
  if not BankListOptions[GetRealmName()][1] then return end
  if BankListOptions[GetRealmName()][1]["guild_checked"] then
	if not BankListGuildInfo then return end
	if not BankListGuildInfo[GetRealmName()] then return end
	if not BankListOptions[GetRealmName()][1]["guild_name"] then
		BankListOptions[GetRealmName()][1]["guild_name"] = BankGUI:GetGuild(1);
	end
	for i = 1, BankGUI:GetNumGuilds() do
		if BankListGuildInfo[GetRealmName()][i]["money"] then
			if BankListGuildInfo[GetRealmName()][i]["name"] == BankGUI:GetGuild(PlayerIndex) then bank_gold_tot = (BankListGuildInfo[GetRealmName()][i]["money"]/10000) end
			bank_gold = BankListGuildInfo[GetRealmName()][i]["money"]/10000;
		else bank_gold = 0.0 end
		playerinfo.text = format("%s (%.2f G)", BankListGuildInfo[GetRealmName()][i]["name"], bank_gold);
		playerinfo.value = BankListGuildInfo[GetRealmName()][i]["name"];
		playerinfo.func = BankGUIPlayerDropDown_OnClick;
		playerinfo.owner = this:GetParent();
		playerinfo.checked = nil;
		UIDropDownMenu_AddButton(playerinfo);
 	end
	BankGUITotalGold:SetText( format(GOLD_GUILD,bank_gold_tot) );
  else
	if not BankListPlayers then return end
	if not BankListPlayers[GetRealmName()] then return end
	playerinfo.text = "All Characters";
	playerinfo.value = "All Characters";
	playerinfo.func = BankGUIPlayerDropDown_OnClick;
	playerinfo.owner = this:GetParent();
	playerinfo.checked = nil;
	UIDropDownMenu_AddButton(playerinfo);
	for i = 1, table.getn(BankListPlayers[GetRealmName()]) do
		if BankListPlayers[GetRealmName()][i]["money"] then
			bank_gold_tot = bank_gold_tot + (BankListPlayers[GetRealmName()][i]["money"]/10000);
			bank_gold = BankListPlayers[GetRealmName()][i]["money"]/10000;
		else bank_gold = 0.0 end
		playerinfo.text = format("%s (%.2f G)", BankListPlayers[GetRealmName()][i]["name"], bank_gold);
		playerinfo.value = BankListPlayers[GetRealmName()][i]["name"];
		playerinfo.func = BankGUIPlayerDropDown_OnClick;
		playerinfo.owner = this:GetParent();
		playerinfo.checked = nil;
		UIDropDownMenu_AddButton(playerinfo);
 	end
	BankGUITotalGold:SetText( format(GOLD_BANK,bank_gold_tot) );
  end
end

function BankGUIPlayerDropDown_OnClick()
  UIDropDownMenu_SetSelectedID(this.owner, this:GetID());
  PlayerIndex = this:GetID();
  if BankListOptions[GetRealmName()][1]["guild_checked"] then
	SelectedID = BankGUI:GetGuild(PlayerIndex);
	BankListOptions[GetRealmName()][1]["guild_name"] = SelectedID;
	UIDropDownMenu_SetText(BankGUIPlayerDropDown, SelectedID);
	if SelectedID == "" then
		BankGUITotalGold:SetText( format(GOLD_GUILD,0.0) );
		BankGUIDeleteButton:Disable();
	else
		BankGUITotalGold:SetText( format(GOLD_GUILD,(BankListGuildInfo[GetRealmName()][PlayerIndex]["money"]/10000)) );
		BankGUIDeleteButton:Enable();
	end
  else
	if PlayerIndex == 1 then
		SelectedID = nil;
		BankListOptions[GetRealmName()][1]["player_name"] = nil;
		BankGUIDeleteButton:Disable();
	else
		SelectedID = BankListPlayers[GetRealmName()][PlayerIndex-1]["name"];
		UIDropDownMenu_SetText(BankGUIPlayerDropDown, SelectedID);
		BankGUIDeleteButton:Enable();
		BankListOptions[GetRealmName()][1]["player_name"] = SelectedID;
	end
  end
  BankGUI:UpdateFilter(nil);
end

function BankGUILinkDropDown_Initialize(self, level)
  local linkinfo = UIDropDownMenu_CreateInfo();
  local i, friendsonline, name, lvl, class, area, connected = 0, false;
  if level == nil then level = 1 end
  if level == 1 then
	for i = 1, table.getn(linktochattypes) do
		linkinfo.text = linktochattypes[i][1];
		linkinfo.value = { ["Level1_Key"] = linktochattypes[i][1] };
		linkinfo.func = BankGUILinkDropDown_OnClick;
		linkinfo.owner = this:GetParent();
		linkinfo.checked = nil;
		linkinfo.isTitle = linktochattypes[i][3];
		linkinfo.hasArrow = linktochattypes[i][2];
		if linkinfo.hasArrow then linkinfo.nested = 1 else linkinfo.nested = 0 end
		linkinfo.notCheckable = true;
		linkinfo.disabled = nil;
		if linktochattypes[i][1] == "FRIEND" then
			for i = 1, GetNumFriends() do
				name, lvl, class, area, connected = GetFriendInfo(i);
				if name and connected then friendsonline = true end
			end
			if not friendsonline then linkinfo.disabled = 1 end
		elseif linktochattypes[i][1] == "WHISPERS" then
			if table.getn(Wisp_Data) == 0 then linkinfo.disabled = 1 end
		elseif linktochattypes[i][1] == "RAID" then
			if GetNumRaidMembers() == 0 then linkinfo.disabled = 1 end
		elseif linktochattypes[i][1] == "PARTY" then
			if GetNumPartyMembers() == 0 then linkinfo.disabled = 1 end
		elseif linktochattypes[i][1] == "GUILD" then
			if not GetGuildInfo("player") then linkinfo.disabled = 1 end
		end
		UIDropDownMenu_AddButton(linkinfo, level);
 	end
  elseif level == 2 then
	ShowFriends();
	local friend, name, lvl, class, area, connected;
	local Level1_Key = UIDROPDOWNMENU_MENU_VALUE["Level1_Key"];
	Link_Data[Level1_Key] = {};
	if Level1_Key == "FRIEND" then
		for i = 1, GetNumFriends() do
			name, lvl, class, area, connected = GetFriendInfo(i);
			if name and connected then
				friend = { ["name"] = name; };
				table.insert(Link_Data[Level1_Key], friend);
			end
		end
	else
		for i = 1, table.getn(Wisp_Data) do
			friend = Wisp_Data[i];
			table.insert(Link_Data[Level1_Key], friend);
		end
	end
	for i = 1, table.getn(Link_Data[Level1_Key]) do
		linkinfo.text = Link_Data[Level1_Key][i]["name"];
		linkinfo.value = { ["Level1_Key"] = Level1_Key; ["Sublevel_Key"] = Link_Data[Level1_Key][i]["name"]; };
		linkinfo.func = BankGUIFriend_OnClick;
		linkinfo.owner = this:GetParent();
		linkinfo.checked = nil;
		linkinfo.hasArrow = false;
		linkinfo.notCheckable = true;
		linkinfo.isTitle = false;
		linkinfo.disabled = false;
		UIDropDownMenu_AddButton(linkinfo, level);
 	end
  end
end

function BankGUILinkDropDown_OnClick()
	local bankinfo = BankGUI:GetItemByIndex(ClickedIndex);
	if linktochattypes[this:GetID()] and linktochattypes[this:GetID()][2]~=true then
		if TypesIndex == 4 and not BankListOptions[GetRealmName()][1]["guild_checked"] then
			SendChatMessage( format("BankGUI: %s %s (%s)", bankinfo["name"], bankinfo["item"], bankinfo["amount"]), linktochattypes[this:GetID()][1], nil)
		else
			SendChatMessage(bankinfo["item"], linktochattypes[this:GetID()][1],nil)
		end
	end
end

function BankGUIFriend_OnClick()
	local bankinfo = BankGUI:GetItemByIndex(ClickedIndex);
	if TypesIndex == 4 and not BankListOptions[GetRealmName()][1]["guild_checked"] then
		SendChatMessage( format("BankGUI: %s %s (%s)", bankinfo["name"], bankinfo["item"], bankinfo["amount"]), "WHISPER", nil, UIDropDownMenuButton_GetName(this));
	else
		SendChatMessage(bankinfo["item"], "WHISPER", nil, UIDropDownMenuButton_GetName(this));
	end
end

function BankGUIDetailsFactionInsignia_OnClick(button)
	if  TypesIndex == 4 and not BankListOptions[GetRealmName()][1]["guild_checked"] then return end
	if (button == "LeftButton") then
		local bankinfo = BankGUI:GetItemByIndex(SelectedIndex);
		if IsShiftKeyDown() then
			if ChatFrameEditBox:IsVisible() then ChatFrameEditBox:Insert(bankinfo["item"])
			else bank_chat:AddMessage(bankinfo["item"])
			end
		elseif (IsControlKeyDown()) then DressUpItemLink(bankinfo["item"])
		else bank_chat:AddMessage(bankinfo["item"])
		end
	end
end

function BankGUIDetailsFactionInsignia_OnEnter()
	local bankinfo = BankGUI:GetItemByIndex(SelectedIndex);
	GameTooltip:SetOwner(this,"ANCHOR_BOTTOMRIGHT");
	GameTooltip:ClearLines();
	GameTooltip:SetHyperlink(bankinfo["item"]);
end

function BankGUI:UpdateUI()
	local numCharacters = BankGUI:GetNumCharacters();
	local nameText, bankinfo, disp, i, blButton;
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture;
	local selectedBankGUI = BankGUI:GetSelectedBankGUI();

	local blOffset = FauxScrollFrame_GetOffset(getglobal("BankGUIScrollFrame"));
	local blIndex;

	if (numCharacters > 0) then
		if (selectedBankGUI == 0 or selectedBankGUI > numCharacters) then
			BankGUI:SetSelectedBankGUI(1);
			selectedBankGUI = 1;
		end
	end

	for i = 1, BANKGUIS_TO_DISPLAY, 1 do
		blIndex = i + blOffset;
		disp = "";
		bankinfo = BankGUI:GetItemByIndex(blIndex);
		nameText = getglobal("BankGUIButton" .. i .. "ButtonTextName");
		blButton = getglobal("BankGUIButton" .. i);
		if bankinfo then
			if bankinfo["type"] == "-4" then
				disp = format("%s: %s (%s)", bankinfo["name"], bankinfo["item"], bankinfo["amount"]);
			else
				itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(bankinfo["item"]);
				if itemStackCount == nil then itemStackCount = 1 end
				disp = bankinfo["item"];
				if itemStackCount ~= 1 then disp = disp ..format(" (%i)", bankinfo["amount"]) end
			end
		end
		nameText:SetText(disp);
		blButton:SetID(blIndex);

		-- Update the highlight
		if (blIndex == selectedBankGUI) then
			blButton:LockHighlight();
		else
			blButton:UnlockHighlight();
		end

		if (blIndex > numCharacters) then
			blButton:Hide();
		else
			blButton:Show();
		end
	end

	-- ScrollFrame stuff
	FauxScrollFrame_Update(getglobal("BankGUIScrollFrame"), numCharacters, BANKGUIS_TO_DISPLAY, FRIENDS_FRAME_BANKGUI_HEIGHT);
end

function BankGUI:UpdateFilter(filter)
  local bankinfo, i, currtable;
  local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture;
  if filter~=nil then filterstring = string.lower(filter) end
  BankFilter = {};
  BankFilter[GetRealmName()] = {};
  if BankListOptions[GetRealmName()][1]["guild_checked"] then
	if BankListGuildItems[GetRealmName()] and BankListGuildItems[GetRealmName()][SelectedID] then
	for i = 1, table.getn(BankListGuildItems[GetRealmName()][SelectedID]) do
		bankinfo = BankListGuildItems[GetRealmName()][SelectedID][i];
		bankinfo["bank"] = true;
		if filterstring == "" then table.insert(BankFilter[GetRealmName()], bankinfo)
		elseif string.find( string.lower(bankinfo["item"]),filterstring ) then table.insert(BankFilter[GetRealmName()], bankinfo)
		end
	end
	end
  else
	for i = 1, table.getn(BankListItems[GetRealmName()]) do
		bankinfo = BankListItems[GetRealmName()][i];
		itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture = GetItemInfo(bankinfo["item"]);
		if ( TypesIndex == 1 or (TypesIndex == 4 and bankinfo["type"] == "-4") or (TypesIndex == 2 and bankinfo["bank"] and bankinfo["type"] ~= "-4") or (TypesIndex == 3 and not bankinfo["bank"] and bankinfo["type"] ~= "-4") ) then
			if SelectedID == nil then
				if filterstring == "" then table.insert(BankFilter[GetRealmName()], bankinfo)
				elseif TypesIndex == 2 and itemEquipLoc and _G[itemEquipLoc] then
					if string.find(string.lower(bankinfo["item"]),filterstring) or string.find(string.lower(_G[itemEquipLoc]),filterstring) then table.insert(BankFilter[GetRealmName()], bankinfo) end
				else
					if string.find(string.lower(bankinfo["item"]),filterstring) then table.insert(BankFilter[GetRealmName()], bankinfo) end
				end
			elseif filterstring == "" then
				if string.find(bankinfo["name"],SelectedID)~=nil then table.insert(BankFilter[GetRealmName()], bankinfo) end
			else
				if TypesIndex == 2 and itemEquipLoc and _G[itemEquipLoc] then
					if string.find(bankinfo["name"],SelectedID)~=nil and ( string.find(string.lower(bankinfo["item"]),filterstring) or string.find(string.lower(_G[itemEquipLoc]),filterstring) ) then table.insert(BankFilter[GetRealmName()], bankinfo) end
				else
					if string.find(bankinfo["name"],SelectedID)~=nil and string.find(string.lower(bankinfo["item"]),filterstring) then table.insert(BankFilter[GetRealmName()], bankinfo) end
				end
			end
		end
	end
  end
  getglobal("BankGUIDetailsFrame"):Hide();
  BankGUI:UpdateUI();
end

function BankGUI_Update()
	BankGUI:UpdateUI();
end
